//: DatabaseInfoImpl.c
#include "com_hp_turboimage_DatabaseInfoImpl.h"

/* DBINFO */
JNIEXPORT void JNICALL 
Java_com_hp_turboimage_DatabaseInfoImpl_DBINFO(JNIEnv    *env, 
                                           jobject    this, 
                                           jbyteArray j_basename, 
                                           jobject    j_qualifier, 
                                           jint       j_mode, 
                                           jobject    j_status, 
                                           jbyteArray j_buffer) {

   // Get JNI parms into C types
   jbyte         *base = (*env)->GetByteArrayElements(env, j_basename, 0);
   jclass   c_DBStatus = (*env)->GetObjectClass(env, j_status);
   jfieldID f_halfword = (*env)->GetFieldID(env, c_DBStatus, "halfword", "[S");
   jobject  p_halfword = (*env)->GetObjectField(env, j_status, f_halfword);
   jshort  *a_halfword = (*env)->GetShortArrayElements(env, p_halfword, 0);
   const char  *buffer = (*env)->GetByteArrayElements(env, j_buffer, 0);
   jshort         mode = j_mode;

   jclass jlstring = (*env)->FindClass(env,"java/lang/String");
   jclass jlshort  = (*env)->FindClass(env,"java/lang/Short");

   if ((*env)->IsInstanceOf(env, j_qualifier, jlstring)) {
      // qualifier is a String
      const char *qualifier = (*env)->GetStringUTFChars(env, j_qualifier, 0);
      dbinfo(base, qualifier, &mode, a_halfword, (char *) buffer);
      (*env)->ReleaseStringUTFChars(env, j_qualifier, qualifier);
   } else if ((*env)->IsInstanceOf(env, j_qualifier, jlshort)) {
      // qualifier is a Short
      jmethodID getValue;
      short qualifier;
      getValue  = (*env)->GetMethodID(env, jlshort, "shortValue", "()S");
      qualifier = (*env)->CallShortMethod(env, j_qualifier, getValue);
      dbinfo(base, &qualifier, &mode, a_halfword, (char *) buffer);
   } else {
      printf("Wrong class as DBINFO qualifier (must be Short or String)\n");
   }

   if (a_halfword[0] < 0) {
       ThrowException(env, "DBINFO", a_halfword);
   }

   (*env)->ReleaseByteArrayElements(env, j_buffer, (char *) buffer, 0);
   (*env)->ReleaseByteArrayElements(env, j_basename, base, 0);
   (*env)->ReleaseShortArrayElements(env, p_halfword, a_halfword, 0);

}

