//: Dataset.java

package com.hp.turboimage;

import java.rmi.Remote;
import java.rmi.RemoteException;

/** Interface to TurboIMAGE datasets. 
  * @version 2.1 (RMI enabled) March 1998
  * @author Mike Yawn
  */
public interface Dataset extends Remote {

// Access to attributes
   public String getSetname() throws RemoteException;

// Dataset access functions
   public boolean readCurrent(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean readSerial(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean readSerialBackward(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean readDirected(Entry entry, int recnum) 
                  throws IMAGEException, RemoteException;
   public boolean readChained(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean readChainedBackward(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean readCalculated(Entry entry, Object value) 
                  throws IMAGEException, RemoteException;
   public boolean readPrimary(Entry entry, Object value) 
                  throws IMAGEException, RemoteException;
   public boolean find(String searchItem, Object value) 
                  throws IMAGEException, RemoteException;
   public boolean put(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean update(Entry entry) 
                  throws IMAGEException, RemoteException;
   public boolean delete() 
                  throws IMAGEException, RemoteException;

// Dataset locking
   public boolean lock() 
                  throws IMAGEException, RemoteException;
   public boolean attemptLock() 
                  throws IMAGEException, RemoteException;
   public boolean lock(LockDescriptor descriptor) 
                  throws IMAGEException, RemoteException;
   public boolean attemptLock(LockDescriptor descriptor)
                  throws IMAGEException, RemoteException;
   public boolean unlock() 
                  throws IMAGEException, RemoteException;

// New APIs for version 2.1
   public boolean close() 
                  throws IMAGEException, RemoteException;
   public boolean reinitialize()
                  throws IMAGEException, RemoteException;
}
