//: IMAGEException.java

package com.hp.turboimage;

/** This class is used to represent TurboIMAGE error
 *  conditions.  TurboIMAGE intrinsics can return a
 *  zero (success), a negative error number (failure),
 *  or a positive condition number (warning).  For
 *  intrinsic calls that return a zero, the Java
 *  wrapper returns a boolean value of 'true'.  For
 *  intrinsic calls that return a warning (positive
 *  status), the Java wrapper returns a boolean value
 *  of 'false'.  For intrinsic calls that return an
 *  error (negative status), an exception will be
 *  thrown.  The C interface code to the intrinsics
 *  will call DBERROR to obtain a text message to be
 *  used as the exception description.
 *
 * @version 2.0 (RMI enabled) January 1998
 * @author  Mike Yawn
 */
public class IMAGEException extends Exception
                            implements java.io.Serializable {
   public IMAGEException(String s) {
       super(s);
   }
}
