//: SerializedBeanApp.java

import java.io.*;
import java.util.zip.*;

/** This demo shows reading in and executing a previously 
  * serialized bean.  
  */
public class SerializedBeanApp {

    public static void main (String[] argv) throws java.io.IOException {

        try {
            FileInputStream fis = new FileInputStream("myBean.ser");
            GZIPInputStream gzis = new GZIPInputStream(fis);
            ObjectInputStream in = new ObjectInputStream(gzis);
            System.out.println("Reading serialized bean");
            SimpleQueryBean bean = (SimpleQueryBean)in.readObject();
            System.out.println("Executing bean");
            bean.execute();
        } catch (Exception e) { 
            System.out.println(e); 
            System.in.read();  // wait for dismissal
        }
    }
}

