//: SimpleQueryApp

import java.io.*;
import java.util.zip.*;

public class SimpleQueryApp {
    
    public static void main(String[] argv) throws java.io.IOException {
        
        SimpleQueryBean bean = new SimpleQueryBean();
        
        // Database
        bean.setOpenDB(true);
        bean.setRemoteDB(true);
        bean.setRemoteHost("belle.cup.hp.com");
        bean.setBasename("EMPDB.IMAGE.JAVA");
        bean.setPassword("PASSWORD");
        
        // Dataset
        bean.setOpenDS(true);
        bean.setSetname("EMPDTL");
        
        // Display results, don't return them
        bean.setDisplay(true);
        
        bean.execute();
        
        // Save the bean
        try {
            FileOutputStream fos = new FileOutputStream("myBean.ser");
            GZIPOutputStream gzos = new GZIPOutputStream(fos);
            ObjectOutputStream out = new ObjectOutputStream(gzos);
            out.writeObject(bean);
            out.flush();
            out.close();
        } catch (Exception e) { 
            System.out.println(e); 
            System.out.println("Press return to continue . . .");
            System.in.read();
        }
    }
}
        
        